Rails console doesn't load: cannot load such file -- minitest/unit
Description

On a 1.2.0-RC2 install on EL6, we don't have any test related packages.  This causes the Rails console to fail:

/opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require': cannot load su

ch file -- minitest/unit (LoadError)

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:251:in `block in require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:236:in `load_dependency'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:251:in `require'

    from /opt/rh/ruby193/root/usr/share/ruby/test/unit/assertions.rb:1:in `<top (required)>'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:251:in `block in require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:236:in `load_dependency'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:251:in `require'

    from /opt/rh/ruby193/root/usr/share/ruby/test/unit/testcase.rb:1:in `<top (required)>'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:251:in `block in require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:236:in `load_dependency'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:251:in `require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/test_case

.rb:1:in `<top (required)>'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:251:in `block in require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:236:in `load_dependency'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:251:in `require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/console/app.rb:2:in `<t

op (required)>'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:36:in `require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:251:in `block in require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc
ies.rb:236:in `load_dependency'

    from /opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/dependenc

ies.rb:251:in `require'

    from /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/application.rb:302:in `

initialize_console'

    from /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/application.rb:152:in `

load_console'

    from /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/commands/console.rb:27:

in `start'

    from /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/commands/console.rb:8:i

n `start'

    from /opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/commands.rb:41:in `<top

 (required)>'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:60:in `require'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:60:in `rescue in requi

re'

    from /opt/rh/ruby193/root/usr/share/rubygems/rubygems/custom_require.rb:35:in `require'

    from script/rails:6:in `<main>'

Related issues:

Related to Foreman - Bug #2701: Error when foreman-console is installed: cann... Closed 06/24/2013

Associated revisions

Revision 95234b21 - 06/17/2013 11:20 AM - Lukas Zapletal

fixes #2650 - adding minitest dependency for console

Revision 9e3f1dff - 06/17/2013 11:53 AM - Dominic Cleal

refs #2650 - fix minitest version

Revision 50f31137 - 06/17/2013 12:33 PM - Lukas Zapletal

fixes #2650 - adding minitest dependency for console

(cherry picked from commit 95234b21bc9fba36206274f8996a0f933b2d4d33)

Revision b2314c2c - 06/17/2013 12:34 PM - Dominic Cleal

refs #2650 - fix minitest version

(cherry picked from commit 9e3f1dff75a3a60568fa39fd3b8c52665f9819ac)

History

#1 - 06/11/2013 06:56 AM - Dominic Cleal

- Priority changed from Normal to High

#2 - 06/17/2013 05:18 AM - Lukas Zapletal

- Status changed from New to Assigned

- Assignee set to Lukas Zapletal

Yami yami

#3 - 06/17/2013 06:54 AM - Ohad Levy

this would require a couple of line patches to rails itself, its fixed in rails 4.0

see https://github.com/rails/rails/issues/6907

#4 - 06/17/2013 06:55 AM - Ohad Levy

more specifically https://github.com/rails/rails/pull/7349/files

#5 - 06/17/2013 08:18 AM - Lukas Zapletal

Ok this was hard to find. But it seems to be easy fix. Anyway, interesting subject:

It looks like Ruby deveopers bundles some libraries (like minitest) which they use for internal stuff (e.g. implementation for test-unit). Unfortunately the

way they do that (standard rubygem) allows users to use those libraries (they export public API). There are couple of problems with this approach - it

is being discussed on Fedora and Ruby lists.

The main issue is some projects, including activesupport, do use minitest and do rely on minitest being bundled with Ruby 1.9+ but this will hopefully
change in future.

Resolution: To add minitest as Foreman require in SPEC and add it to main Gemfile until this gets sorted in the upstream projects. Fixing this

upstream would be challenging since there are two opinions: one group (me) says it's not official API (it's not documented) and should not be used,

the other group says "they bundle it, we will use it"-

#6 - 06/17/2013 12:17 PM - Lukas Zapletal

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset 95234b21bc9fba36206274f8996a0f933b2d4d33.

#7 - 06/24/2013 05:02 AM - Gaël Chamoulaud

Hi guys,

I got this error this morning after a yum update (EL6 and 1.2.0-0.4.RC3).

The bundler.d/console.rb seems to be ok and contains the Lukas patch.

Gaël

#8 - 06/24/2013 05:10 AM - Dominic Cleal

Gaël Chamoulaud wrote:

Hi guys,

I got this error this morning after a yum update (EL6 and 1.2.0-0.4.RC3).

The bundler.d/console.rb seems to be ok and contains the Lukas patch.

Gaël

 When using the console, or doing something else?  In theory it shouldn't be needed for normal operations.

#9 - 06/24/2013 05:13 AM - Gaël Chamoulaud

The console is not available anymore for me. I've just the passenger error page with the ruby stack message!

#10 - 06/24/2013 05:19 AM - Dominic Cleal

It's a bug in the console.rb change, it should read like this I think:

gem 'minitest', '~> 4.7', :require => 'minitest/unit'

 Filed as #2701.

#11 - 06/24/2013 05:28 AM - Gaël Chamoulaud

Thx Dominic, It works now !
